/*
Inbox

Inbox API can be used for low level integration and enables direct communication with you contact base.   In most cases you will use our interaction templates for communication, but our api also allows you to send message directly.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package inboxapi

import (
	"encoding/json"
)

// checks if the ContactAddress type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ContactAddress{}

// ContactAddress struct for ContactAddress
type ContactAddress struct {
	Street *string `json:"street,omitempty"`
	HouseNumber *string `json:"house_number,omitempty"`
	DoorNumber *string `json:"door_number,omitempty"`
	City *string `json:"city,omitempty"`
	Zip *string `json:"zip,omitempty"`
	// 2-character ISO code (DE, US)
	Country *string `json:"country,omitempty"`
	CountryName *string `json:"country_name,omitempty"`
	CompanyName *string `json:"company_name,omitempty"`
}

// NewContactAddress instantiates a new ContactAddress object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewContactAddress() *ContactAddress {
	this := ContactAddress{}
	return &this
}

// NewContactAddressWithDefaults instantiates a new ContactAddress object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewContactAddressWithDefaults() *ContactAddress {
	this := ContactAddress{}
	return &this
}

// GetStreet returns the Street field value if set, zero value otherwise.
func (o *ContactAddress) GetStreet() string {
	if o == nil || IsNil(o.Street) {
		var ret string
		return ret
	}
	return *o.Street
}

// GetStreetOk returns a tuple with the Street field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ContactAddress) GetStreetOk() (*string, bool) {
	if o == nil || IsNil(o.Street) {
		return nil, false
	}
	return o.Street, true
}

// HasStreet returns a boolean if a field has been set.
func (o *ContactAddress) HasStreet() bool {
	if o != nil && !IsNil(o.Street) {
		return true
	}

	return false
}

// SetStreet gets a reference to the given string and assigns it to the Street field.
func (o *ContactAddress) SetStreet(v string) {
	o.Street = &v
}

// GetHouseNumber returns the HouseNumber field value if set, zero value otherwise.
func (o *ContactAddress) GetHouseNumber() string {
	if o == nil || IsNil(o.HouseNumber) {
		var ret string
		return ret
	}
	return *o.HouseNumber
}

// GetHouseNumberOk returns a tuple with the HouseNumber field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ContactAddress) GetHouseNumberOk() (*string, bool) {
	if o == nil || IsNil(o.HouseNumber) {
		return nil, false
	}
	return o.HouseNumber, true
}

// HasHouseNumber returns a boolean if a field has been set.
func (o *ContactAddress) HasHouseNumber() bool {
	if o != nil && !IsNil(o.HouseNumber) {
		return true
	}

	return false
}

// SetHouseNumber gets a reference to the given string and assigns it to the HouseNumber field.
func (o *ContactAddress) SetHouseNumber(v string) {
	o.HouseNumber = &v
}

// GetDoorNumber returns the DoorNumber field value if set, zero value otherwise.
func (o *ContactAddress) GetDoorNumber() string {
	if o == nil || IsNil(o.DoorNumber) {
		var ret string
		return ret
	}
	return *o.DoorNumber
}

// GetDoorNumberOk returns a tuple with the DoorNumber field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ContactAddress) GetDoorNumberOk() (*string, bool) {
	if o == nil || IsNil(o.DoorNumber) {
		return nil, false
	}
	return o.DoorNumber, true
}

// HasDoorNumber returns a boolean if a field has been set.
func (o *ContactAddress) HasDoorNumber() bool {
	if o != nil && !IsNil(o.DoorNumber) {
		return true
	}

	return false
}

// SetDoorNumber gets a reference to the given string and assigns it to the DoorNumber field.
func (o *ContactAddress) SetDoorNumber(v string) {
	o.DoorNumber = &v
}

// GetCity returns the City field value if set, zero value otherwise.
func (o *ContactAddress) GetCity() string {
	if o == nil || IsNil(o.City) {
		var ret string
		return ret
	}
	return *o.City
}

// GetCityOk returns a tuple with the City field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ContactAddress) GetCityOk() (*string, bool) {
	if o == nil || IsNil(o.City) {
		return nil, false
	}
	return o.City, true
}

// HasCity returns a boolean if a field has been set.
func (o *ContactAddress) HasCity() bool {
	if o != nil && !IsNil(o.City) {
		return true
	}

	return false
}

// SetCity gets a reference to the given string and assigns it to the City field.
func (o *ContactAddress) SetCity(v string) {
	o.City = &v
}

// GetZip returns the Zip field value if set, zero value otherwise.
func (o *ContactAddress) GetZip() string {
	if o == nil || IsNil(o.Zip) {
		var ret string
		return ret
	}
	return *o.Zip
}

// GetZipOk returns a tuple with the Zip field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ContactAddress) GetZipOk() (*string, bool) {
	if o == nil || IsNil(o.Zip) {
		return nil, false
	}
	return o.Zip, true
}

// HasZip returns a boolean if a field has been set.
func (o *ContactAddress) HasZip() bool {
	if o != nil && !IsNil(o.Zip) {
		return true
	}

	return false
}

// SetZip gets a reference to the given string and assigns it to the Zip field.
func (o *ContactAddress) SetZip(v string) {
	o.Zip = &v
}

// GetCountry returns the Country field value if set, zero value otherwise.
func (o *ContactAddress) GetCountry() string {
	if o == nil || IsNil(o.Country) {
		var ret string
		return ret
	}
	return *o.Country
}

// GetCountryOk returns a tuple with the Country field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ContactAddress) GetCountryOk() (*string, bool) {
	if o == nil || IsNil(o.Country) {
		return nil, false
	}
	return o.Country, true
}

// HasCountry returns a boolean if a field has been set.
func (o *ContactAddress) HasCountry() bool {
	if o != nil && !IsNil(o.Country) {
		return true
	}

	return false
}

// SetCountry gets a reference to the given string and assigns it to the Country field.
func (o *ContactAddress) SetCountry(v string) {
	o.Country = &v
}

// GetCountryName returns the CountryName field value if set, zero value otherwise.
func (o *ContactAddress) GetCountryName() string {
	if o == nil || IsNil(o.CountryName) {
		var ret string
		return ret
	}
	return *o.CountryName
}

// GetCountryNameOk returns a tuple with the CountryName field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ContactAddress) GetCountryNameOk() (*string, bool) {
	if o == nil || IsNil(o.CountryName) {
		return nil, false
	}
	return o.CountryName, true
}

// HasCountryName returns a boolean if a field has been set.
func (o *ContactAddress) HasCountryName() bool {
	if o != nil && !IsNil(o.CountryName) {
		return true
	}

	return false
}

// SetCountryName gets a reference to the given string and assigns it to the CountryName field.
func (o *ContactAddress) SetCountryName(v string) {
	o.CountryName = &v
}

// GetCompanyName returns the CompanyName field value if set, zero value otherwise.
func (o *ContactAddress) GetCompanyName() string {
	if o == nil || IsNil(o.CompanyName) {
		var ret string
		return ret
	}
	return *o.CompanyName
}

// GetCompanyNameOk returns a tuple with the CompanyName field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ContactAddress) GetCompanyNameOk() (*string, bool) {
	if o == nil || IsNil(o.CompanyName) {
		return nil, false
	}
	return o.CompanyName, true
}

// HasCompanyName returns a boolean if a field has been set.
func (o *ContactAddress) HasCompanyName() bool {
	if o != nil && !IsNil(o.CompanyName) {
		return true
	}

	return false
}

// SetCompanyName gets a reference to the given string and assigns it to the CompanyName field.
func (o *ContactAddress) SetCompanyName(v string) {
	o.CompanyName = &v
}

func (o ContactAddress) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ContactAddress) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Street) {
		toSerialize["street"] = o.Street
	}
	if !IsNil(o.HouseNumber) {
		toSerialize["house_number"] = o.HouseNumber
	}
	if !IsNil(o.DoorNumber) {
		toSerialize["door_number"] = o.DoorNumber
	}
	if !IsNil(o.City) {
		toSerialize["city"] = o.City
	}
	if !IsNil(o.Zip) {
		toSerialize["zip"] = o.Zip
	}
	if !IsNil(o.Country) {
		toSerialize["country"] = o.Country
	}
	if !IsNil(o.CountryName) {
		toSerialize["country_name"] = o.CountryName
	}
	if !IsNil(o.CompanyName) {
		toSerialize["company_name"] = o.CompanyName
	}
	return toSerialize, nil
}

type NullableContactAddress struct {
	value *ContactAddress
	isSet bool
}

func (v NullableContactAddress) Get() *ContactAddress {
	return v.value
}

func (v *NullableContactAddress) Set(val *ContactAddress) {
	v.value = val
	v.isSet = true
}

func (v NullableContactAddress) IsSet() bool {
	return v.isSet
}

func (v *NullableContactAddress) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableContactAddress(val *ContactAddress) *NullableContactAddress {
	return &NullableContactAddress{value: val, isSet: true}
}

func (v NullableContactAddress) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableContactAddress) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


